<?php

namespace MoSfSyncSalesforce;

use MoSfSyncSalesforce\Helper\PluginConstants;

class Customer {
	public $email;
	public $phone;
    private $defaultCustomerKey = "16555";
    private $defaultApiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

    public function mo_sf_sync_submit_contact_us($email, $phone, $query, $call_setup, $demo_request=false,$integration_selected='',$integration_trial='') {
       
        $url = PluginConstants::HOSTNAME.'/moas/rest/customer/contact-us';
        $current_user = wp_get_current_user();

        $application_type = $this->mo_sf_sync_get_application_type();
        if($call_setup)
            $query = '[Call Request - Object Data Sync for Salesforce] ' . $query .'<br><br>Selected Application Type : ' . $application_type .'<br><br>Site URL : '.home_url();
        else{
            if($demo_request == true && ($integration_trial == 'integration_trial_request' || $integration_trial == 'normal_trial_request'))
                $query = '[Trial Request - Object Data Sync for Salesforce] ' . $query .  ' <br><br>Requested Integration : ' . $integration_selected.' <br><br>Selected Application Type : ' . $application_type  .'<br><br>Site URL : '.home_url();
            
            else if($demo_request)
                $query = '[Demo Request - Object Data Sync for Salesforce] ' . $query .  ' <br><br>Requested Integration : ' . $integration_selected.'  <br><br>Selected Application Type : ' . $application_type  .'<br><br>Site URL : '.home_url();

            else
                $query = '[Object Data Sync for Salesforce] ' . $query.'<br><br>Selected Application Type : ' . $application_type .'<br><br>Site URL : '.home_url();
        }
            
        $fields = array (
            'firstName' => $current_user->user_firstname,
            'lastName' => $current_user->user_lastname,
            'company' => sanitize_text_field($_SERVER ['SERVER_NAME']),
            'email' => $email,
            'ccEmail'=>'salesforcesupport@xecurify.com',
            'phone' => $phone,
            'query' => $query
        );

        $field_string = json_encode ( $fields );

        $headers = array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '10',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = wp_remote_post($url, $args);
		return !is_wp_error($response)? $response['body']:implode($response->get_error_messages());

    }

	public function mo_sf_sync_send_email_alert($email,$phone,$message, $demo_request=false){
        
		$url = PluginConstants::HOSTNAME.'/moas/api/notify/send';

		$customerKey = $this->defaultCustomerKey;
		$apiKey =  $this->defaultApiKey;

		$currentTimeInMillis = self::mo_sf_sync_get_timestamp();
		$currentTimeInMillis = number_format ( $currentTimeInMillis, 0, '', '' );
		$stringToHash 		= $customerKey .  $currentTimeInMillis . $apiKey;
		$hashValue 			= hash("sha512", $stringToHash);
		$fromEmail			= 'no-reply@xecurify.com';
		$subject            = "Feedback: Object Data Sync for Salesforce";
		if($demo_request)
			$subject = "DEMO REQUEST: Object Data Sync for Salesforce";
		$site_url=site_url();

		global $user;
		$user         = wp_get_current_user();
    
        $application_type = $this->mo_sf_sync_get_application_type();

		$query        = '[Object Data Sync for Salesforce: ]: ' . $message .'<br><br>Selected Application Type : ' . $application_type; 

		$content='<div >Hello, <br><br>First Name :'.$user->user_firstname.'<br><br>Last  Name :'.$user->user_lastname.'   <br><br>Company :<a href="'.sanitize_text_field($_SERVER['SERVER_NAME']).'" target="_blank" >'.sanitize_text_field($_SERVER['SERVER_NAME']).'</a><br><br>Phone Number :'.$phone.'<br><br>Email :<a href="mailto:'.$email.'" target="_blank">'.$email.'</a><br><br>Query :'.$query.'</div>';


		$fields = array(
			'customerKey'	=> $customerKey,
			'sendEmail' 	=> true,
			'email' 		=> array(
				'customerKey' 	=> $customerKey,
				'fromEmail' 	=> $fromEmail,
				'bccEmail' 		=> $fromEmail,
				'fromName' 		=> 'Xecurify',
				'toEmail' 		=> 'info@xecurify.com',
				'toName' 		=> 'salesforcesupport@xecurify.com',
				'bccEmail'		=> 'salesforcesupport@xecurify.com',
				'subject' 		=> $subject,
				'content' 		=> $content
			),
		);
		$field_string = json_encode($fields);

		$headers = array(
			"Content-Type" => "application/json",
			"Customer-Key" => $customerKey,
			"Timestamp" => $currentTimeInMillis,
			"Authorization" => $hashValue
		);
		$args = array(
			'method' => 'POST',
			'body' => $field_string,
			'timeout' => '10',
			'redirection' => '5',
			'httpversion' => '1.0',
			'blocking' => true,
			'headers' => $headers
		);
		$response = wp_remote_post($url, $args);
		return !is_wp_error($response)? json_decode($response['body'],true):implode($response->get_error_messages());

	}
	
	public function mo_sf_sync_get_timestamp() {
		$url = PluginConstants::HOSTNAME.'/moas/rest/mobile/get-timestamp';
		$response = wp_remote_post($url,array());
		return !is_wp_error($response)? json_decode($response['body'],true):implode($response->get_error_messages());

	}

    public function mo_sf_sync_get_application_type(){
        $config_object = get_option(PluginConstants::CONFIG_OBJECT);
        $resp_object = get_option(PluginConstants::SF_RESPONSE_OBJECT);
        $connection_type = get_option(PluginConstants::CONNECTION_TYPE);
        if( empty($resp_object) && empty($config_object))
            $application_type =  'None';
        else if($connection_type == 'automatic')
            $application_type =  'Pre-connected (Automatic)';
        else
            $application_type = 'Manual (Custom)';
        return $application_type;
    }

    public static function mo_sf_sync_is_customer_logged_in($html_element=false) {
        $email 			= get_option('mo_sf_sync_admin_email');
        $customerKey 	= get_option('mo_sf_sync_admin_customer_key');
        if( ! $email || ! $customerKey || ! is_numeric( trim( $customerKey ) ) ) {
            return $html_element?'disabled':0;
        }
        return $html_element?'':1;
    }

	public static function mo_sf_sync_decrypt_data($data, $key) {
		$strIn = base64_decode($data);
		$key    = openssl_digest($key, 'sha256');
		$method = 'AES-128-ECB';
		$ivSize = openssl_cipher_iv_length($method);
		$iv     = substr($strIn,0,$ivSize);
		$data   = substr($strIn,$ivSize);
		$clear  = openssl_decrypt ($data, $method, $key, OPENSSL_RAW_DATA||OPENSSL_ZERO_PADDING, $iv);

		return $clear;
	}

	public static function mo_sf_sync_encrypt_data($data, $key) {
		$key    = openssl_digest($key, 'sha256');
		$method = 'AES-128-ECB';
		$strCrypt = openssl_encrypt ($data, $method, $key,OPENSSL_RAW_DATA||OPENSSL_ZERO_PADDING);
		return base64_encode($strCrypt);
	}
	
	public static function mo_sf_sync_checkPasswordPattern($password)
    {
        $pattern = '/^[(\w)*(\!\@\#\$\%\^\&\*\.\-\_)*]+$/';
        return !preg_match($pattern, $password);
    }

	public static function mo_sf_sync_deactivate(){
        delete_option('mo_sf_sync_admin_password');
        delete_option('mo_sf_sync_admin_customer_key');
        delete_option('mo_sf_sync_admin_api_key');
        delete_option('mo_sf_sync_customer_token');
        delete_option('vl_check_t');
        delete_option('vl_check_s');
    }
}
