<?php
namespace MoSfSyncSalesforce\Handler;

class BulkActionHandler{
    public function __construct()
    {
        add_filter('handle_bulk_actions-users',array($this, "mo_sf_sync_bulk_action_handler"), 10, 3);
        add_filter('handle_bulk_actions-edit-post',array($this, "mo_sf_sync_bulk_action_handler"), 9, 3);
        add_action('admin_notices', array($this,'mo_sf_sync_bulkaction_notice' ));
    }
    function mo_sf_sync_bulkaction_notice() {
        if (!empty($_REQUEST['sync_user_to_sf'])) {
            $num_changed = (int)sanitize_text_field($_REQUEST['sync_user_to_sf']);
            $base_url = get_option('siteurl');
            $url = $base_url."/wp-admin/users.php";
            printf('<div id="message" class="updated" ><p  style="display:inline-block;position:relative;margin-right: 57.5rem;min-width: 333px;">' . __('%d Users will be synced to Salesforce.', 'sync_user_to_sf') . '</p><a href="%s"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-6 h-6" style="width: 15px; "  >    <path stroke-linecap="round" stroke-linejoin="round" d="M6 18L18 6M6 6l12 12" />
              </svg></a></div>', esc_attr($num_changed),esc_attr($url));
        }
        else  if (!empty($_REQUEST['sync_post_to_sf'])) {
            $num_changed = (int)sanitize_text_field($_REQUEST['sync_post_to_sf']);
            $base_url = get_option('siteurl');
            $url = $base_url."/wp-admin/edit.php";
            printf('<div id="message" class="updated" ><p  style="display:inline-block;position:relative;margin-right: 57.5rem;min-width: 333px;">' . __('%d Posts will be synced to Salesforce.', 'sync_post_to_sf') . '</p><a href="%s"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-6 h-6" style="width: 15px; "  >    <path stroke-linecap="round" stroke-linejoin="round" d="M6 18L18 6M6 6l12 12" />
              </svg></a></div>', esc_attr($num_changed),esc_attr($url));
        }
    }

    function mo_sf_sync_bulk_action_handler($redirect_url,$action,$ids){
       
        global $pagenow;
        if ( $action !== 'sync_user_to_sf' && $action !== 'sync_post_to_sf') 
        {
            return $redirect_url;
        }
        $DataProcessingHandler = DataProcessingHandler::instance();
        $ids_count = count($ids);
    if ($pagenow === 'users.php') {
       
        if ($ids_count>1) {
            $DataProcessingHandler->mo_sf_sync_composite_call_handler($ids);
        }else{
            $DataProcessingHandler->mo_sf_sync_push_to_salesforce($ids[0]);
        }
        
        $redirect_to = add_query_arg('sync_user_to_sf', $ids_count, $redirect_url);
    }    
    else{
        
        if ($ids_count>1) {
            $DataProcessingHandler->mo_sf_sync_composite_call_handler($ids,'post');
        } else {
            $DataProcessingHandler->mo_sf_sync_push_to_salesforce($ids[0],'post');
        }
        
        $redirect_to = add_query_arg('sync_post_to_sf', $ids_count, $redirect_url);
    }    
           
    
      return $redirect_to;
    }
}


