<?php
namespace MoSfSyncSalesforce\Handler;

use MoSfSyncSalesforce\Customer;
use MoSfSyncSalesforce\Services\Utils;

class DemoSetupHandler{

    public static $INTEGRATIONS_TITLE = array(

        'Ultimate_Member'       => 'Ultimate Member',
        'Paid_Membership_Pro'   => 'Paid Membership Pro',
        'WooCommerce'           => 'WooCommerce',
        'Contact_Form_7'        => 'Contact Form 7',
        'Ninja_Forms'           => 'Ninja Forms',
        'Gravity_Forms'         => 'Gravity Forms',
        'WP_Forms'              => 'WP Forms',
        'BuddyPress'            => 'BuddyPress',
        'ACF'                   => 'ACF',
        'CPT_UI'                => 'CPT UI',
        'Affiliate_WP'          =>  'Affiliate WP',
        'learndash'             =>  'Learndash'
    );

    public function mo_sf_sync_request_demo(){
        if($_POST['option'] == 'mo_sf_sync_demo_setup' && check_admin_referer('mo_sf_sync_demo_setup')){
            $this->mo_sf_sync_demo_setup_request();
        }
    }

    public function mo_sf_sync_demo_setup_request(){
            
        if(isset($_POST['demo_email']))
            $demo_email = sanitize_email($_POST['demo_email']);
        else
            wp_send_json_error("Empty email or query");

        $demo_description = sanitize_textarea_field($_POST['demo_description']);
        
        $addons_selected = array();
        $addons = self::$INTEGRATIONS_TITLE;
        foreach($addons as $key => $value){
            if(isset($_POST[$key]) && $_POST[$key] == "true")
                $addons_selected[$key] = $value;
        }
        
        $integrations_selected = implode(', ', array_values($addons_selected));

        if(empty($demo_email)){		
            wp_send_json_error("Empty email or query");
        }

        else {
            $demo_setup = new Customer();
            $response = $demo_setup->mo_sf_sync_submit_contact_us($demo_email, "", $demo_description, false,true,$integrations_selected);
            
            if($response == 'Query submitted.')
                Utils::mo_sf_sync_show_success_message('Demo Request Successful');
            else
                Utils::mo_sf_sync_show_error_message($response);
        }
    }
}
