<?php

namespace MoSfSyncSalesforce\Helper;
include 'BasicEnum.php';

class PluginConstants extends BasicEnum{
     const HOSTNAME  = "https://login.xecurify.com";
     const VERSION   = "1.1.5";
     const ACCESS_TOKEN = "access_token";
     const REFRESH_TOKEN = "refresh_token";

     const MAPPING_OBJECT     = "mo_sf_sync_object";
     const PROVISION_OBJECT   = "mo_sf_sync_provision";
     const SF_RESPONSE_OBJECT = "mo_sf_sync_salesforce_response";
     const CONFIG_OBJECT      = "mo_sf_sync_config";

     const CLIENT_SECRET    = "client_secret";
     const CLIENT_ID        = "client_id";
     const REDIRECT_URI     = "redirect_uri";
     const ENVIRONMENT      = "env_select";
     const ENVIRONMENT_LINK = "env_link";
     const AUTO_USER_UPDATE = "automatic_user_update";
     const AUDIT_LOGS       = "mo_sf_sync_enable_audit_logs";

     const WPTOSF = "sync wp to sf";
	const SFTOWP = "sync sf to wp";

     const SELECTED_OBJECT = "object_select";
     const WP_OBJECT = "wp_object_select";
     const CONNECTION_TYPE = "mo_sf_sync_connection_type";
     const LAST_AUTH_TIME   = "mo_sf_sync_last_auth_time";

     const TRANSIENT_CONFIG_OBJECT      = "mo_sf_sync_config_transient";

     const SUGGESTED_ADDONS = array("Employee-Staff-Directory" => ["title"=>"Employee Staff Directory",
     "text" => "Employee Directory plugin creates a central directory of your Employees, Staff, Members, or Team and displays the listing on your WordPress site. Provides an easily searchable, sortable list of all the Employees, group or tag your Employees based on custom categories, Password protect your Employee details, and many more.",
     "link" => "https://wordpress.org/plugins/employee-staff-directory/","knw-link"=>"https://plugins.miniorange.com/employee-directory-and-staff-listing-for-wordpress"]);

     const EXISTING_USER = 'Existing User';
     const REMOVED_ACCOUNT = 'removed_account';

     const INTEGRATIONS_DESC = array(
          'ultimate_member'               =>  'Create User profile with Ultimate Member with the data fetched from the Salesforce CRM. Easily show any data from Salesforce on your user profile.',
          'contact_form_7'                =>  'Sync any and all data forms filled by your website visitors with Salesforce. With our Contact Form 7 integration you can immediately sync data to Salesforce when a website visitor registers for an event, subscribes to a newsletter, etc.', 
          'woo_commerce'                  =>  'Keep your Woocommerce data in constant sync with Salesforce, sync data to Salesforce depending on various woocommerce events like order status change, order getting placed, etc. Create Leads, Order Records, Cases, Opportunities, etc based on order data.', 
          'paid_membership_pro'           =>  'Map Membership level, User credentials, User information from Membership Checkout page with a Salesforce object field. Keep your membership in constant sync with Salesforce and maintain an effective membership lifecycle.',
          'acf'                           =>  'Sync data of any custom fields of any type with Salesforce Object fields, this integration allows you to extend your normal WordPress data store to cover data of various types as per your needs',
          'cpt_ui'                        =>  'Keep all of your custom posts bi-directionally synced with Salesforce, this integration allows you to sync custom posts to and from Salesforce in real time whenever a custom post is created/updated in WordPress it will be synced to Salesforce and same for other way around.',
          'ninja_forms'                   =>  'Our Ninja Forms integration allows you to sync any data submitted by your users to Salesforce objects, for example you will be able to immediately create a Lead in Salesforce if someone fills out a contact us form, you can also set up accounts and contacts to be created when user registration happens.',
          'wp_forms'                      =>  'Sync data of any form on your site: your contact forms, lead magnets, webinar sign-up forms, and more with Salesforce objects. Each form on your website can create a different object in Salesforce. And you can map the form fields to the fields in Salesforce however you need to.', 
          'gravity_forms'                 =>  'Allows you to connect WordPress Gravity Forms with Salesforce. To automatically add/update Gravity Forms form submissions to your Salesforce objects, simply integrate your Gravity Forms form with any Salesforce object.', 
          'learndash'                     =>  'The integration allows you to sync all your course data with Salesforce you can easily manage your course data and student access management based on data stored in Salesforce.',
          'buddypress'                    =>  'Sync data of your community site created with buddypress with Salesforce, sync buddypress attributes of a user like profile content, groups, etc to Salesforce',
          'Affiliate_WP'                  =>  'Connect AffiliateWP to Salesforce and sync all your customer and affiliate data to Salesforce, alternatively you can sync data fro Salesforce to AffiliateWp',
      );

     const INTEGRATIONS_TITLE = array(
          'ultimate_member'               =>  'Ultimate Member',
          'paid_membership_pro'           =>  'Paid Membership Pro',
          'woo_commerce'                  =>  'Woocommerce',
          'contact_form_7'                =>  'Contact Form 7',
          'ninja_forms'                   =>  'Ninja Forms',
          'gravity_forms'                 =>  'Gravity Forms',
          'wp_forms'                      =>  'WP Forms',
          'buddypress'                    =>  'Buddypress',
          'acf'                           =>  'Advance Custom Fields',
          'cpt_ui'                        =>  'Custom Post Type UI',
          'Affiliate_WP'                  =>  'Affiliate WP',
          'learndash'                     =>  'Learndash'
      );

     const INTEGRATIONS_URL = array(
          'ultimate_member'               =>  'https://plugins.miniorange.com/connect-ultimate-member-to-salesforce-in-wordpress',
          'paid_membership_pro'           =>  'https://plugins.miniorange.com/salesforce-paid-memberships-pro-integration',
          'woo_commerce'                  =>  'https://plugins.miniorange.com/woocommerce-salesforce-integration-sync-orders',
          'contact_form_7'                =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'ninja_forms'                   =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'gravity_forms'                 =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'wp_forms'                      =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'buddypress'                    =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'acf'                           =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce',
          'cpt_ui'                        =>  'https://plugins.miniorange.com/scheduled-automation-sync-to-wp-using-salesforce-cpt-ui-acf-integration',
          'Affiliate_WP'                  =>  'https://plugins.miniorange.com/scheduled-automation-sync-to-wp-using-salesforce-cpt-ui-acf-integration',
          'learndash'                     =>  'https://plugins.miniorange.com/wordpress-object-sync-for-salesforce'
     );

     const INTEGRATIONS_ADVERTISEMENT = array(
          'um\core\Member_Directory'      =>  'Ultimate Member',
          'PMPro_Membership_Level'        =>  'Paid Membership Pro',
          'WC_Admin_Assets'               =>  'Woocommerce', 
          'WPCF7_Integration'             =>  'Contact Form 7', 
          'NF_Admin_AllFormsTable'        =>  'Ninja Forms', 
          'WPForms_Settings'              =>  'WP Forms', 
          'BuddyPress'                    =>  'Buddypress', 
          'ACF'                           =>  'Advance Custom Fields', 
          'cptui_admin_ui'                =>  'Custom Post Type UI', 
          'sfwd-lms/sfwd_lms.php'         =>  'Learndash', 
          'GFForms'                       =>  'Gravity Forms', 
          'Affiliate_WP'                  =>  'Affiliate WP'
      );

}