<?php

add_action( 'admin_init', 'mo_sf_sync_import_export');

use MoSfSyncSalesforce\Helper\PluginConstants;
use MoSfSyncSalesforce\Services\Utils;
use MoSfSyncSalesforce\Services\DBUtils;

function mo_sf_sync_import_export(){
	if (array_key_exists('option',$_POST) && $_POST['option']=='mo_sf_sync_keep_settings_on_deletion' && check_admin_referer('mo_sf_sync_keep_settings_on_deletion')) {
		if (array_key_exists('mo_sf_sync_keep_settings_on_deletion', $_POST))
			update_option('mo_sf_sync_keep_settings_on_deletion', 'true');
		else
			update_option('mo_sf_sync_keep_settings_on_deletion', '');
	} else if (array_key_exists('option',$_POST) && $_POST['option']=='mo_sf_sync_export' && check_admin_referer('mo_sf_sync_export')){
		$configuration_array = array();
		$mapping_object=get_option('mo_sf_sync_object');
		$config_object=get_option('mo_sf_sync_config');
		$provision_object=get_option('mo_sf_sync_provision');
		$configuration_array["PROVISION_OBJECT"]=maybe_unserialize($provision_object);
		$db = DBUtils::instance();
		$mapping_object = $db->mo_sf_sync_get_all_mapping_data();
		$configuration_array["MAPPING_OBJECT"]= $mapping_object;
		$configuration_array["CONFIG_OBJECT"]=maybe_unserialize($config_object);
		$configuration_array["Version_dependencies"] = mo_sf_sync_get_version_informations();
		$version = phpversion();
		if(substr($version,0 ,3) === '5.3'){
			$json_string=(json_encode($configuration_array, JSON_PRETTY_PRINT));
		} else {
			$json_string=(json_encode($configuration_array, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
		}
		header("Content-Disposition: attachment; filename=miniorange-sf_sync-config.json");
		echo $json_string;
		exit;
		
	} else if(array_key_exists('option',$_POST) && $_POST['option']=='mo_sf_sync_import') {
		if ( ! function_exists( 'wp_handle_upload' ) )
			require_once( ABSPATH . 'wp-admin/includes/file.php' );
		
		$file_type = $_FILES['configuration_file']['type'];
		$file_ext = substr($file_type, strpos($file_type, "/")+1);
		if($file_ext != "json"){
			update_option('mo_sf_sync_message','Please upload a valid configuration file in .json format');
			return;
		}
		if ( ! empty( $_FILES['configuration_file']['tmp_name'] ) ) {
			$file                = @file_get_contents( $_FILES['configuration_file']['tmp_name'] );
			$configuration_array = json_decode( $file, true );
			mo_sf_sync_update_configuration_array( $configuration_array );
		}
		
		Utils::mo_sf_sync_show_success_message('Configuration import completed! Please Authorize again to connect to salesforce.');
	}
}


function mo_sf_sync_get_version_informations() {
	$array_version = array();
	$array_version["Plugin_version"] = PluginConstants::VERSION;
	$array_version["PHP_version"] = phpversion();
	$array_version["Wordpress_version"] = get_bloginfo('version');
	return $array_version;
}

function mo_sf_sync_update_configuration_array($configuration_array){
	$db = DBUtils::instance();
	$db->mo_sf_sync_insert_imported_mapping_data($configuration_array["MAPPING_OBJECT"]);
	update_option('mo_sf_sync_provision',$configuration_array["PROVISION_OBJECT"]);
	update_option('mo_sf_sync_config',$configuration_array["CONFIG_OBJECT"]);
}
